// 该类 TaskList 继承自 Node 类，是一个表示任务列表的类，用于管理任务列表及其相关操作
public class TaskList extends Node {
    // 日志标签，使用类的简单名称
    private static final String TAG = TaskList.class.getSimpleName();
    // 任务列表的索引
    private int mIndex;
    // 存储任务列表中的任务
    private ArrayList<Task> mChildren;


    // 构造函数，初始化任务列表，创建一个空的任务列表并设置初始索引
    public TaskList() {
        super();
        mChildren = new ArrayList<Task>();
        mIndex = 1;
    }


    // 获取创建操作的 JSON 对象
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject();


        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);


            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);


            // index
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mIndex);


            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null");
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP);
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);


        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-create jsonobject");
        }


        return js;
    }


    // 获取更新操作的 JSON 对象
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject();


        try {
            // action_type
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);


            // action_id
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);


            // id
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());


            // entity_delta
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName());
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted());
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity);


        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-update jsonobject");
        }


        return js;
    }


    // 根据远程的 JSON 对象设置任务列表的内容
    public void setContentByRemoteJSON(JSONObject js) {
        if (js!= null) {
            try {
                // id
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }


                // last_modified
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }


                // name
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }


            } catch (JSONException e) {
                Log.e(TAG, e.toString());
                e.printStackTrace();
                throw new ActionFailureException("fail to get tasklist content from jsonobject");
            }
        }
    }


    // 根据本地的 JSON 对象设置任务列表的内容
    public void setContentByLocalJSON(JSONObject js) {
        if (js == null ||!js.has(GTaskStringUtils.META_HEAD_NOTE)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable");
        }


        try {
            JSONObject folder = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);


            if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                String name = folder.getString(NoteColumns.SNIPPET);
                setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + name);
            } else if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                if (folder.getLong(NoteColumns.ID) == Notes.ID_ROOT_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_DEFAULT);
                else if (folder.getLong(NoteColumns.ID) == Notes.ID_CALL_RECORD_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX
                            + GTaskStringUtils.FOLDER_CALL_NOTE);
                else
                    Log.e(TAG, "invalid system folder");
            } else {
                Log.e(TAG, "error type");
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }
    }


    // 从任务列表的内容获取本地的 JSON 对象
    public JSONObject getLocalJSONFromContent() {
        try {
            JSONObject js = new JSONObject();
            JSONObject folder = new JSONObject();


            String folderName = getName();
            if (getName().startsWith(GTaskStringUtils.MIUI_FOLDER_PREFFIX))
                folderName = folderName.substring(GTaskStringUtils.MIUI_FOLDER_PREFFIX.length(),
                        folderName.length());
            folder.put(NoteColumns.SNIPPET, folderName);
            if (folderName.equals(GTaskStringUtils.FOLDER_DEFAULT)
                    || folderName.equals(GTaskStringUtils.FOLDER_CALL_NOTE))
                folder.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
            else
                folder.put(NoteColumns.TYPE, Notes.TYPE_FOLDER);


            js.put(GTaskStringUtils.META_HEAD_NOTE, folder);


            return js;
        } catch (JSONException e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
            return null;
        }
    }


    // 获取同步操作的状态
    public int getSyncAction(Cursor c) {
        try {
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 本地没有更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 两边都没有更新
                    return SYNC_ACTION_NONE;
                } else {
                    // 将远程更新应用到本地
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // 验证 gtask 的 ID
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match");
                    return SYNC_ACTION_ERROR;
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 仅本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    // 对于文件夹冲突，仅应用本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString());
            e.printStackTrace();
        }


        return SYNC_ACTION_ERROR;
    }


    // 获取任务列表中任务的数量
    public int getChildTaskCount() {
        return mChildren.size();
    }


    // 向任务列表中添加任务
    public boolean addChildTask(Task task) {
        boolean ret = false;
        if (task!= null &&!mChildren.contains(task)) {
            ret = mChildren.add(task);
            if (ret) {
                // 设置前一个兄弟任务和父任务
                task.setPriorSibling(mChildren.isEmpty()? null : mChildren
                       .get(mChildren.size() - 1));
                task.setParent(this);
            }
        }
        return ret;
    }


    // 在指定索引处添加任务
    public boolean addChildTask(Task task, int index) {
        if (index < 0 || index > mChildren.size()) {
            Log.e(TAG, "add child task: invalid index");
            return false;
        }


        int pos = mChildren.indexOf(task);
        if (task!= null && pos == -1) {
            mChildren.add(index, task);


            // 更新任务列表
            Task preTask = null;
            Task afterTask = null;
            if (index!= 0)
                preTask = mChildren.get(index - 1);
            if (index!= mChildren.size() - 1)
                afterTask = mChildren.get(index + 1);


            task.setPriorSibling(preTask);
            if (afterTask!= null)
                afterTask.setPriorSibling(task);
        }


        return true;
    }


    // 从任务列表中移除任务
    public boolean removeChildTask(Task task) {
        boolean ret = false;
        int index = mChildren.indexOf(task);
        if (index!= -1) {
            ret = mChildren.remove(task);


            if (ret) {
                // 重置前一个兄弟任务和父任务
                task.setPriorSibling(null);
                task.setParent(null);


                // 更新任务列表
                if (index!= mChildren.size()) {
                    mChildren.get(index).setPriorSibling(
                            index == 0? null : mChildren.get(index - 1));
                }
            }
        }
        return ret;
    }


    // 移动任务到指定索引位置
    public boolean moveChildTask(Task task, int index) {


        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "move child task: invalid index");
            return false;
        }


        int pos = mChildren.indexOf(task);
        if (pos == -1) {
            Log.e(TAG, "move child task: the task should in the list");
            return false;
        }


        if (pos == index)
            return true;
        return (removeChildTask(task) && addChildTask(task, index));
    }


    // 根据全局唯一标识符查找任务
    public Task findChildTaskByGid(String gid) {
        for (int i = 0; i < mChildren.size(); i++) {
            Task t = mChildren.get(i);
            if (t.getGid().equals(gid)) {
                return t;
            }
        }
        return null;
    }


    // 获取任务在任务列表中的索引
    public int getChildTaskIndex(Task task) {
        return mChildren.indexOf(task);
    }


    // 根据索引获取任务
    public Task getChildTaskByIndex(int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "getTaskByIndex: invalid index");
            return null;
        }
        return mChildren.get(index);
    }


    // 根据全局唯一标识符获取任务（可能是笔误，应为 getChildTaskByGid）
    public Task getChilTaskByGid(String gid) {
        for (Task task : mChildren) {
            if (task.getGid().equals(gid))
                return task;
        }
        return null;
    }


    // 获取任务列表中的任务列表
    public ArrayList<Task> getChildTaskList() {
        return this.mChildren;
    }


    // 设置任务列表的索引
    public void setIndex(int index) {
        this.mIndex = index;
    }


    // 获取任务列表的索引
    public int getIndex() {
        return this.mIndex;
    }
}